// main.cpp : Main program
//
// 08.09.1998 / DH - First release
// 16.11.1998 / DH - Test with AR transfer
// 23.11.1998 / DH - Tests
//
// Copyright (c) 1998 Daniel Hartmeier. All rights reserved.

#include "Handler.hpp"
#include <stdio.h>

// -------------------------------------------------------------------

extern "C" DISPENV GsDISPENV;

// -------------------------------------------------------------------

#define OT_LENGTH  1
#define SPRITE_CNT 2047

// -------------------------------------------------------------------

GsOT     WorldOT[2];
GsOT_TAG OTTags[2][1<<OT_LENGTH];
PACKET   GpuPacketArea[2][SPRITE_CNT*sizeof(GsSPRITE)];
u_long pad = 0;

// -------------------------------------------------------------------


void main()
  {
    // Call this when running from AR or CD, otherwise disable
  //(*(void (*)(void)) 0x80010030)(); // Thanks to Barubary

    RickHandler *handler = new RickHandler();

    SetVideoMode(MODE_PAL);
    GsInitGraph(320, 256, 4, 0, 0);
    GsDefDispBuff(0, 0, 0, 256);
    GsDISPENV.screen.h = 256; // According to Robert Swan in scee.yaroze.beginners

    for (int i = 0; i < 2; ++i)
      {
        WorldOT[i].length = OT_LENGTH;
        WorldOT[i].org = OTTags[i];
      }
    u_char *bb0, *bb1;
    GetPadBuf(&bb0, &bb1);
    u_long pad;

    FntLoad(960, 256);
    FntOpen(1, 1, 192, 192, 0, 512);

    int h = 0;
    bool terminate = false;
    while (!terminate)
      {
        int activeBuff = GsGetActiveBuff();
        GsSetWorkBase((PACKET*)GpuPacketArea[activeBuff]);
        GsOT *ot = &WorldOT[activeBuff];
        GsClearOt(0, 0, ot);

        pad = (~(*(bb0+3) | *(bb0+2) << 8 | *(bb1+3) << 16 | *(bb1+2) << 24));
        terminate = handler->act(pad);
        handler->draw(ot);

        FntPrint("%3d", h);
        FntFlush(-1);
        DrawSync(0);
        h = VSync(0);
        GsSwapDispBuff();
        handler->clear(ot);
        GsDrawOt(ot);
      }

    ResetGraph(0);

    delete handler; handler = 0;
    return;
  }

// -------------------------------------------------------------------

void load(char *filename, unsigned char *address)
  {
    int read = CdReadFile(filename, (u_long*)address, 0);
    if (read <= 0)
      {
        // Handle file read error
      }
    else
      {
        unsigned char result[128];
        int remaining = CdReadSync(0, result);
        if (remaining)
          {
            // Handle file read sync error
          }
      }
    return;
  }

// -------------------------------------------------------------------
